(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
// export the class if we are in a Node-like system.
if (typeof module === 'object' && module.exports === exports)
  exports = module.exports = SemVer;

// The debug function is excluded entirely from the minified version.
/* nomin */ var debug;
/* nomin */ if (typeof process === 'object' &&
    /* nomin */ process.env &&
    /* nomin */ process.env.NODE_DEBUG &&
    /* nomin */ /\bsemver\b/i.test(process.env.NODE_DEBUG))
  /* nomin */ debug = function() {
    /* nomin */ var args = Array.prototype.slice.call(arguments, 0);
    /* nomin */ args.unshift('SEMVER');
    /* nomin */ console.log.apply(console, args);
    /* nomin */ };
/* nomin */ else
  /* nomin */ debug = function() {};

// Note: this is the semver.org version of the spec that it implements
// Not necessarily the package version of this code.
exports.SEMVER_SPEC_VERSION = '2.0.0';

// The actual regexps go on exports.re
var re = exports.re = [];
var src = exports.src = [];
var R = 0;

// The following Regular Expressions can be used for tokenizing,
// validating, and parsing SemVer version strings.

// ## Numeric Identifier
// A single `0`, or a non-zero digit followed by zero or more digits.

var NUMERICIDENTIFIER = R++;
src[NUMERICIDENTIFIER] = '0|[1-9]\\d*';
var NUMERICIDENTIFIERLOOSE = R++;
src[NUMERICIDENTIFIERLOOSE] = '[0-9]+';


// ## Non-numeric Identifier
// Zero or more digits, followed by a letter or hyphen, and then zero or
// more letters, digits, or hyphens.

var NONNUMERICIDENTIFIER = R++;
src[NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-][a-zA-Z0-9-]*';


// ## Main Version
// Three dot-separated numeric identifiers.

var MAINVERSION = R++;
src[MAINVERSION] = '(' + src[NUMERICIDENTIFIER] + ')\\.' +
                   '(' + src[NUMERICIDENTIFIER] + ')\\.' +
                   '(' + src[NUMERICIDENTIFIER] + ')';

var MAINVERSIONLOOSE = R++;
src[MAINVERSIONLOOSE] = '(' + src[NUMERICIDENTIFIERLOOSE] + ')\\.' +
                        '(' + src[NUMERICIDENTIFIERLOOSE] + ')\\.' +
                        '(' + src[NUMERICIDENTIFIERLOOSE] + ')';

// ## Pre-release Version Identifier
// A numeric identifier, or a non-numeric identifier.

var PRERELEASEIDENTIFIER = R++;
src[PRERELEASEIDENTIFIER] = '(?:' + src[NUMERICIDENTIFIER] +
                            '|' + src[NONNUMERICIDENTIFIER] + ')';

var PRERELEASEIDENTIFIERLOOSE = R++;
src[PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[NUMERICIDENTIFIERLOOSE] +
                                 '|' + src[NONNUMERICIDENTIFIER] + ')';


// ## Pre-release Version
// Hyphen, followed by one or more dot-separated pre-release version
// identifiers.

var PRERELEASE = R++;
src[PRERELEASE] = '(?:-(' + src[PRERELEASEIDENTIFIER] +
                  '(?:\\.' + src[PRERELEASEIDENTIFIER] + ')*))';

var PRERELEASELOOSE = R++;
src[PRERELEASELOOSE] = '(?:-?(' + src[PRERELEASEIDENTIFIERLOOSE] +
                       '(?:\\.' + src[PRERELEASEIDENTIFIERLOOSE] + ')*))';

// ## Build Metadata Identifier
// Any combination of digits, letters, or hyphens.

var BUILDIDENTIFIER = R++;
src[BUILDIDENTIFIER] = '[0-9A-Za-z-]+';

// ## Build Metadata
// Plus sign, followed by one or more period-separated build metadata
// identifiers.

var BUILD = R++;
src[BUILD] = '(?:\\+(' + src[BUILDIDENTIFIER] +
             '(?:\\.' + src[BUILDIDENTIFIER] + ')*))';


// ## Full Version String
// A main version, followed optionally by a pre-release version and
// build metadata.

// Note that the only major, minor, patch, and pre-release sections of
// the version string are capturing groups.  The build metadata is not a
// capturing group, because it should not ever be used in version
// comparison.

var FULL = R++;
var FULLPLAIN = 'v?' + src[MAINVERSION] +
                src[PRERELEASE] + '?' +
                src[BUILD] + '?';

src[FULL] = '^' + FULLPLAIN + '$';

// like full, but allows v1.2.3 and =1.2.3, which people do sometimes.
// also, 1.0.0alpha1 (prerelease without the hyphen) which is pretty
// common in the npm registry.
var LOOSEPLAIN = '[v=\\s]*' + src[MAINVERSIONLOOSE] +
                 src[PRERELEASELOOSE] + '?' +
                 src[BUILD] + '?';

var LOOSE = R++;
src[LOOSE] = '^' + LOOSEPLAIN + '$';

var GTLT = R++;
src[GTLT] = '((?:<|>)?=?)';

// Something like "2.*" or "1.2.x".
// Note that "x.x" is a valid xRange identifer, meaning "any version"
// Only the first item is strictly required.
var XRANGEIDENTIFIERLOOSE = R++;
src[XRANGEIDENTIFIERLOOSE] = src[NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
var XRANGEIDENTIFIER = R++;
src[XRANGEIDENTIFIER] = src[NUMERICIDENTIFIER] + '|x|X|\\*';

var XRANGEPLAIN = R++;
src[XRANGEPLAIN] = '[v=\\s]*(' + src[XRANGEIDENTIFIER] + ')' +
                   '(?:\\.(' + src[XRANGEIDENTIFIER] + ')' +
                   '(?:\\.(' + src[XRANGEIDENTIFIER] + ')' +
                   '(?:(' + src[PRERELEASE] + ')' +
                   ')?)?)?';

var XRANGEPLAINLOOSE = R++;
src[XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[XRANGEIDENTIFIERLOOSE] + ')' +
                        '(?:\\.(' + src[XRANGEIDENTIFIERLOOSE] + ')' +
                        '(?:\\.(' + src[XRANGEIDENTIFIERLOOSE] + ')' +
                        '(?:(' + src[PRERELEASELOOSE] + ')' +
                        ')?)?)?';

// >=2.x, for example, means >=2.0.0-0
// <1.x would be the same as "<1.0.0-0", though.
var XRANGE = R++;
src[XRANGE] = '^' + src[GTLT] + '\\s*' + src[XRANGEPLAIN] + '$';
var XRANGELOOSE = R++;
src[XRANGELOOSE] = '^' + src[GTLT] + '\\s*' + src[XRANGEPLAINLOOSE] + '$';

// Tilde ranges.
// Meaning is "reasonably at or greater than"
var LONETILDE = R++;
src[LONETILDE] = '(?:~>?)';

var TILDETRIM = R++;
src[TILDETRIM] = '(\\s*)' + src[LONETILDE] + '\\s+';
re[TILDETRIM] = new RegExp(src[TILDETRIM], 'g');
var tildeTrimReplace = '$1~';

var TILDE = R++;
src[TILDE] = '^' + src[LONETILDE] + src[XRANGEPLAIN] + '$';
var TILDELOOSE = R++;
src[TILDELOOSE] = '^' + src[LONETILDE] + src[XRANGEPLAINLOOSE] + '$';

// Caret ranges.
// Meaning is "at least and backwards compatible with"
var LONECARET = R++;
src[LONECARET] = '(?:\\^)';

var CARETTRIM = R++;
src[CARETTRIM] = '(\\s*)' + src[LONECARET] + '\\s+';
re[CARETTRIM] = new RegExp(src[CARETTRIM], 'g');
var caretTrimReplace = '$1^';

var CARET = R++;
src[CARET] = '^' + src[LONECARET] + src[XRANGEPLAIN] + '$';
var CARETLOOSE = R++;
src[CARETLOOSE] = '^' + src[LONECARET] + src[XRANGEPLAINLOOSE] + '$';

// A simple gt/lt/eq thing, or just "" to indicate "any version"
var COMPARATORLOOSE = R++;
src[COMPARATORLOOSE] = '^' + src[GTLT] + '\\s*(' + LOOSEPLAIN + ')$|^$';
var COMPARATOR = R++;
src[COMPARATOR] = '^' + src[GTLT] + '\\s*(' + FULLPLAIN + ')$|^$';


// An expression to strip any whitespace between the gtlt and the thing
// it modifies, so that `> 1.2.3` ==> `>1.2.3`
var COMPARATORTRIM = R++;
src[COMPARATORTRIM] = '(\\s*)' + src[GTLT] +
                      '\\s*(' + LOOSEPLAIN + '|' + src[XRANGEPLAIN] + ')';

// this one has to use the /g flag
re[COMPARATORTRIM] = new RegExp(src[COMPARATORTRIM], 'g');
var comparatorTrimReplace = '$1$2$3';


// Something like `1.2.3 - 1.2.4`
// Note that these all use the loose form, because they'll be
// checked against either the strict or loose comparator form
// later.
var HYPHENRANGE = R++;
src[HYPHENRANGE] = '^\\s*(' + src[XRANGEPLAIN] + ')' +
                   '\\s+-\\s+' +
                   '(' + src[XRANGEPLAIN] + ')' +
                   '\\s*$';

var HYPHENRANGELOOSE = R++;
src[HYPHENRANGELOOSE] = '^\\s*(' + src[XRANGEPLAINLOOSE] + ')' +
                        '\\s+-\\s+' +
                        '(' + src[XRANGEPLAINLOOSE] + ')' +
                        '\\s*$';

// Star ranges basically just allow anything at all.
var STAR = R++;
src[STAR] = '(<|>)?=?\\s*\\*';

// Compile to actual regexp objects.
// All are flag-free, unless they were created above with a flag.
for (var i = 0; i < R; i++) {
  debug(i, src[i]);
  if (!re[i])
    re[i] = new RegExp(src[i]);
}

exports.parse = parse;
function parse(version, loose) {
  var r = loose ? re[LOOSE] : re[FULL];
  return (r.test(version)) ? new SemVer(version, loose) : null;
}

exports.valid = valid;
function valid(version, loose) {
  var v = parse(version, loose);
  return v ? v.version : null;
}


exports.clean = clean;
function clean(version, loose) {
  var s = parse(version, loose);
  return s ? s.version : null;
}

exports.SemVer = SemVer;

function SemVer(version, loose) {
  if (version instanceof SemVer) {
    if (version.loose === loose)
      return version;
    else
      version = version.version;
  } else if (typeof version !== 'string') {
    throw new TypeError('Invalid Version: ' + version);
  }

  if (!(this instanceof SemVer))
    return new SemVer(version, loose);

  debug('SemVer', version, loose);
  this.loose = loose;
  var m = version.trim().match(loose ? re[LOOSE] : re[FULL]);

  if (!m)
    throw new TypeError('Invalid Version: ' + version);

  this.raw = version;

  // these are actually numbers
  this.major = +m[1];
  this.minor = +m[2];
  this.patch = +m[3];

  // numberify any prerelease numeric ids
  if (!m[4])
    this.prerelease = [];
  else
    this.prerelease = m[4].split('.').map(function(id) {
      return (/^[0-9]+$/.test(id)) ? +id : id;
    });

  this.build = m[5] ? m[5].split('.') : [];
  this.format();
}

SemVer.prototype.format = function() {
  this.version = this.major + '.' + this.minor + '.' + this.patch;
  if (this.prerelease.length)
    this.version += '-' + this.prerelease.join('.');
  return this.version;
};

SemVer.prototype.inspect = function() {
  return '<SemVer "' + this + '">';
};

SemVer.prototype.toString = function() {
  return this.version;
};

SemVer.prototype.compare = function(other) {
  debug('SemVer.compare', this.version, this.loose, other);
  if (!(other instanceof SemVer))
    other = new SemVer(other, this.loose);

  return this.compareMain(other) || this.comparePre(other);
};

SemVer.prototype.compareMain = function(other) {
  if (!(other instanceof SemVer))
    other = new SemVer(other, this.loose);

  return compareIdentifiers(this.major, other.major) ||
         compareIdentifiers(this.minor, other.minor) ||
         compareIdentifiers(this.patch, other.patch);
};

SemVer.prototype.comparePre = function(other) {
  if (!(other instanceof SemVer))
    other = new SemVer(other, this.loose);

  // NOT having a prerelease is > having one
  if (this.prerelease.length && !other.prerelease.length)
    return -1;
  else if (!this.prerelease.length && other.prerelease.length)
    return 1;
  else if (!this.prerelease.length && !other.prerelease.length)
    return 0;

  var i = 0;
  do {
    var a = this.prerelease[i];
    var b = other.prerelease[i];
    debug('prerelease compare', i, a, b);
    if (a === undefined && b === undefined)
      return 0;
    else if (b === undefined)
      return 1;
    else if (a === undefined)
      return -1;
    else if (a === b)
      continue;
    else
      return compareIdentifiers(a, b);
  } while (++i);
};

// preminor will bump the version up to the next minor release, and immediately
// down to pre-release. premajor and prepatch work the same way.
SemVer.prototype.inc = function(release) {
  switch (release) {
    case 'premajor':
      this.inc('major');
      this.inc('pre');
      break;
    case 'preminor':
      this.inc('minor');
      this.inc('pre');
      break;
    case 'prepatch':
      this.inc('patch');
      this.inc('pre');
      break;
    // If the input is a non-prerelease version, this acts the same as
    // prepatch.
    case 'prerelease':
      if (this.prerelease.length === 0)
        this.inc('patch');
      this.inc('pre');
      break;
    case 'major':
      this.major++;
      this.minor = -1;
    case 'minor':
      this.minor++;
      this.patch = 0;
      this.prerelease = [];
      break;
    case 'patch':
      // If this is not a pre-release version, it will increment the patch.
      // If it is a pre-release it will bump up to the same patch version.
      // 1.2.0-5 patches to 1.2.0
      // 1.2.0 patches to 1.2.1
      if (this.prerelease.length === 0)
        this.patch++;
      this.prerelease = [];
      break;
    // This probably shouldn't be used publically.
    // 1.0.0 "pre" would become 1.0.0-0 which is the wrong direction.
    case 'pre':
      if (this.prerelease.length === 0)
        this.prerelease = [0];
      else {
        var i = this.prerelease.length;
        while (--i >= 0) {
          if (typeof this.prerelease[i] === 'number') {
            this.prerelease[i]++;
            i = -2;
          }
        }
        if (i === -1) // didn't increment anything
          this.prerelease.push(0);
      }
      break;

    default:
      throw new Error('invalid increment argument: ' + release);
  }
  this.format();
  return this;
};

exports.inc = inc;
function inc(version, release, loose) {
  try {
    return new SemVer(version, loose).inc(release).version;
  } catch (er) {
    return null;
  }
}

exports.compareIdentifiers = compareIdentifiers;

var numeric = /^[0-9]+$/;
function compareIdentifiers(a, b) {
  var anum = numeric.test(a);
  var bnum = numeric.test(b);

  if (anum && bnum) {
    a = +a;
    b = +b;
  }

  return (anum && !bnum) ? -1 :
         (bnum && !anum) ? 1 :
         a < b ? -1 :
         a > b ? 1 :
         0;
}

exports.rcompareIdentifiers = rcompareIdentifiers;
function rcompareIdentifiers(a, b) {
  return compareIdentifiers(b, a);
}

exports.compare = compare;
function compare(a, b, loose) {
  return new SemVer(a, loose).compare(b);
}

exports.compareLoose = compareLoose;
function compareLoose(a, b) {
  return compare(a, b, true);
}

exports.rcompare = rcompare;
function rcompare(a, b, loose) {
  return compare(b, a, loose);
}

exports.sort = sort;
function sort(list, loose) {
  return list.sort(function(a, b) {
    return exports.compare(a, b, loose);
  });
}

exports.rsort = rsort;
function rsort(list, loose) {
  return list.sort(function(a, b) {
    return exports.rcompare(a, b, loose);
  });
}

exports.gt = gt;
function gt(a, b, loose) {
  return compare(a, b, loose) > 0;
}

exports.lt = lt;
function lt(a, b, loose) {
  return compare(a, b, loose) < 0;
}

exports.eq = eq;
function eq(a, b, loose) {
  return compare(a, b, loose) === 0;
}

exports.neq = neq;
function neq(a, b, loose) {
  return compare(a, b, loose) !== 0;
}

exports.gte = gte;
function gte(a, b, loose) {
  return compare(a, b, loose) >= 0;
}

exports.lte = lte;
function lte(a, b, loose) {
  return compare(a, b, loose) <= 0;
}

exports.cmp = cmp;
function cmp(a, op, b, loose) {
  var ret;
  switch (op) {
    case '===': ret = a === b; break;
    case '!==': ret = a !== b; break;
    case '': case '=': case '==': ret = eq(a, b, loose); break;
    case '!=': ret = neq(a, b, loose); break;
    case '>': ret = gt(a, b, loose); break;
    case '>=': ret = gte(a, b, loose); break;
    case '<': ret = lt(a, b, loose); break;
    case '<=': ret = lte(a, b, loose); break;
    default: throw new TypeError('Invalid operator: ' + op);
  }
  return ret;
}

exports.Comparator = Comparator;
function Comparator(comp, loose) {
  if (comp instanceof Comparator) {
    if (comp.loose === loose)
      return comp;
    else
      comp = comp.value;
  }

  if (!(this instanceof Comparator))
    return new Comparator(comp, loose);

  debug('comparator', comp, loose);
  this.loose = loose;
  this.parse(comp);

  if (this.semver === ANY)
    this.value = '';
  else
    this.value = this.operator + this.semver.version;
}

var ANY = {};
Comparator.prototype.parse = function(comp) {
  var r = this.loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
  var m = comp.match(r);

  if (!m)
    throw new TypeError('Invalid comparator: ' + comp);

  this.operator = m[1];
  // if it literally is just '>' or '' then allow anything.
  if (!m[2])
    this.semver = ANY;
  else {
    this.semver = new SemVer(m[2], this.loose);

    // <1.2.3-rc DOES allow 1.2.3-beta (has prerelease)
    // >=1.2.3 DOES NOT allow 1.2.3-beta
    // <=1.2.3 DOES allow 1.2.3-beta
    // However, <1.2.3 does NOT allow 1.2.3-beta,
    // even though `1.2.3-beta < 1.2.3`
    // The assumption is that the 1.2.3 version has something you
    // *don't* want, so we push the prerelease down to the minimum.
    if (this.operator === '<' && !this.semver.prerelease.length) {
      this.semver.prerelease = ['0'];
      this.semver.format();
    }
  }
};

Comparator.prototype.inspect = function() {
  return '<SemVer Comparator "' + this + '">';
};

Comparator.prototype.toString = function() {
  return this.value;
};

Comparator.prototype.test = function(version) {
  debug('Comparator.test', version, this.loose);
  return (this.semver === ANY) ? true :
         cmp(version, this.operator, this.semver, this.loose);
};


exports.Range = Range;
function Range(range, loose) {
  if ((range instanceof Range) && range.loose === loose)
    return range;

  if (!(this instanceof Range))
    return new Range(range, loose);

  this.loose = loose;

  // First, split based on boolean or ||
  this.raw = range;
  this.set = range.split(/\s*\|\|\s*/).map(function(range) {
    return this.parseRange(range.trim());
  }, this).filter(function(c) {
    // throw out any that are not relevant for whatever reason
    return c.length;
  });

  if (!this.set.length) {
    throw new TypeError('Invalid SemVer Range: ' + range);
  }

  this.format();
}

Range.prototype.inspect = function() {
  return '<SemVer Range "' + this.range + '">';
};

Range.prototype.format = function() {
  this.range = this.set.map(function(comps) {
    return comps.join(' ').trim();
  }).join('||').trim();
  return this.range;
};

Range.prototype.toString = function() {
  return this.range;
};

Range.prototype.parseRange = function(range) {
  var loose = this.loose;
  range = range.trim();
  debug('range', range, loose);
  // `1.2.3 - 1.2.4` => `>=1.2.3 <=1.2.4`
  var hr = loose ? re[HYPHENRANGELOOSE] : re[HYPHENRANGE];
  range = range.replace(hr, hyphenReplace);
  debug('hyphen replace', range);
  // `> 1.2.3 < 1.2.5` => `>1.2.3 <1.2.5`
  range = range.replace(re[COMPARATORTRIM], comparatorTrimReplace);
  debug('comparator trim', range, re[COMPARATORTRIM]);

  // `~ 1.2.3` => `~1.2.3`
  range = range.replace(re[TILDETRIM], tildeTrimReplace);

  // `^ 1.2.3` => `^1.2.3`
  range = range.replace(re[CARETTRIM], caretTrimReplace);

  // normalize spaces
  range = range.split(/\s+/).join(' ');

  // At this point, the range is completely trimmed and
  // ready to be split into comparators.

  var compRe = loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
  var set = range.split(' ').map(function(comp) {
    return parseComparator(comp, loose);
  }).join(' ').split(/\s+/);
  if (this.loose) {
    // in loose mode, throw out any that are not valid comparators
    set = set.filter(function(comp) {
      return !!comp.match(compRe);
    });
  }
  set = set.map(function(comp) {
    return new Comparator(comp, loose);
  });

  return set;
};

// Mostly just for testing and legacy API reasons
exports.toComparators = toComparators;
function toComparators(range, loose) {
  return new Range(range, loose).set.map(function(comp) {
    return comp.map(function(c) {
      return c.value;
    }).join(' ').trim().split(' ');
  });
}

// comprised of xranges, tildes, stars, and gtlt's at this point.
// already replaced the hyphen ranges
// turn into a set of JUST comparators.
function parseComparator(comp, loose) {
  debug('comp', comp);
  comp = replaceCarets(comp, loose);
  debug('caret', comp);
  comp = replaceTildes(comp, loose);
  debug('tildes', comp);
  comp = replaceXRanges(comp, loose);
  debug('xrange', comp);
  comp = replaceStars(comp, loose);
  debug('stars', comp);
  return comp;
}

function isX(id) {
  return !id || id.toLowerCase() === 'x' || id === '*';
}

// ~, ~> --> * (any, kinda silly)
// ~2, ~2.x, ~2.x.x, ~>2, ~>2.x ~>2.x.x --> >=2.0.0 <3.0.0
// ~2.0, ~2.0.x, ~>2.0, ~>2.0.x --> >=2.0.0 <2.1.0
// ~1.2, ~1.2.x, ~>1.2, ~>1.2.x --> >=1.2.0 <1.3.0
// ~1.2.3, ~>1.2.3 --> >=1.2.3 <1.3.0
// ~1.2.0, ~>1.2.0 --> >=1.2.0 <1.3.0
function replaceTildes(comp, loose) {
  return comp.trim().split(/\s+/).map(function(comp) {
    return replaceTilde(comp, loose);
  }).join(' ');
}

function replaceTilde(comp, loose) {
  var r = loose ? re[TILDELOOSE] : re[TILDE];
  return comp.replace(r, function(_, M, m, p, pr) {
    debug('tilde', comp, _, M, m, p, pr);
    var ret;

    if (isX(M))
      ret = '';
    else if (isX(m))
      ret = '>=' + M + '.0.0-0 <' + (+M + 1) + '.0.0-0';
    else if (isX(p))
      // ~1.2 == >=1.2.0- <1.3.0-
      ret = '>=' + M + '.' + m + '.0-0 <' + M + '.' + (+m + 1) + '.0-0';
    else if (pr) {
      debug('replaceTilde pr', pr);
      if (pr.charAt(0) !== '-')
        pr = '-' + pr;
      ret = '>=' + M + '.' + m + '.' + p + pr +
            ' <' + M + '.' + (+m + 1) + '.0-0';
    } else
      // ~1.2.3 == >=1.2.3-0 <1.3.0-0
      ret = '>=' + M + '.' + m + '.' + p + '-0' +
            ' <' + M + '.' + (+m + 1) + '.0-0';

    debug('tilde return', ret);
    return ret;
  });
}

// ^ --> * (any, kinda silly)
// ^2, ^2.x, ^2.x.x --> >=2.0.0 <3.0.0
// ^2.0, ^2.0.x --> >=2.0.0 <3.0.0
// ^1.2, ^1.2.x --> >=1.2.0 <2.0.0
// ^1.2.3 --> >=1.2.3 <2.0.0
// ^1.2.0 --> >=1.2.0 <2.0.0
function replaceCarets(comp, loose) {
  return comp.trim().split(/\s+/).map(function(comp) {
    return replaceCaret(comp, loose);
  }).join(' ');
}

function replaceCaret(comp, loose) {
  var r = loose ? re[CARETLOOSE] : re[CARET];
  return comp.replace(r, function(_, M, m, p, pr) {
    debug('caret', comp, _, M, m, p, pr);
    var ret;

    if (isX(M))
      ret = '';
    else if (isX(m))
      ret = '>=' + M + '.0.0-0 <' + (+M + 1) + '.0.0-0';
    else if (isX(p)) {
      if (M === '0')
        ret = '>=' + M + '.' + m + '.0-0 <' + M + '.' + (+m + 1) + '.0-0';
      else
        ret = '>=' + M + '.' + m + '.0-0 <' + (+M + 1) + '.0.0-0';
    } else if (pr) {
      debug('replaceCaret pr', pr);
      if (pr.charAt(0) !== '-')
        pr = '-' + pr;
      if (M === '0') {
        if (m === '0')
          ret = '=' + M + '.' + m + '.' + p + pr;
        else
          ret = '>=' + M + '.' + m + '.' + p + pr +
                ' <' + M + '.' + (+m + 1) + '.0-0';
      } else
        ret = '>=' + M + '.' + m + '.' + p + pr +
              ' <' + (+M + 1) + '.0.0-0';
    } else {
      if (M === '0') {
        if (m === '0')
          ret = '=' + M + '.' + m + '.' + p;
        else
          ret = '>=' + M + '.' + m + '.' + p + '-0' +
                ' <' + M + '.' + (+m + 1) + '.0-0';
      } else
        ret = '>=' + M + '.' + m + '.' + p + '-0' +
              ' <' + (+M + 1) + '.0.0-0';
    }

    debug('caret return', ret);
    return ret;
  });
}

function replaceXRanges(comp, loose) {
  debug('replaceXRanges', comp, loose);
  return comp.split(/\s+/).map(function(comp) {
    return replaceXRange(comp, loose);
  }).join(' ');
}

function replaceXRange(comp, loose) {
  comp = comp.trim();
  var r = loose ? re[XRANGELOOSE] : re[XRANGE];
  return comp.replace(r, function(ret, gtlt, M, m, p, pr) {
    debug('xRange', comp, ret, gtlt, M, m, p, pr);
    var xM = isX(M);
    var xm = xM || isX(m);
    var xp = xm || isX(p);
    var anyX = xp;

    if (gtlt === '=' && anyX)
      gtlt = '';

    if (gtlt && anyX) {
      // replace X with 0, and then append the -0 min-prerelease
      if (xM)
        M = 0;
      if (xm)
        m = 0;
      if (xp)
        p = 0;

      if (gtlt === '>') {
        // >1 => >=2.0.0-0
        // >1.2 => >=1.3.0-0
        // >1.2.3 => >= 1.2.4-0
        gtlt = '>=';
        if (xM) {
          // no change
        } else if (xm) {
          M = +M + 1;
          m = 0;
          p = 0;
        } else if (xp) {
          m = +m + 1;
          p = 0;
        }
      }


      ret = gtlt + M + '.' + m + '.' + p + '-0';
    } else if (xM) {
      // allow any
      ret = '*';
    } else if (xm) {
      // append '-0' onto the version, otherwise
      // '1.x.x' matches '2.0.0-beta', since the tag
      // *lowers* the version value
      ret = '>=' + M + '.0.0-0 <' + (+M + 1) + '.0.0-0';
    } else if (xp) {
      ret = '>=' + M + '.' + m + '.0-0 <' + M + '.' + (+m + 1) + '.0-0';
    }

    debug('xRange return', ret);

    return ret;
  });
}

// Because * is AND-ed with everything else in the comparator,
// and '' means "any version", just remove the *s entirely.
function replaceStars(comp, loose) {
  debug('replaceStars', comp, loose);
  // Looseness is ignored here.  star is always as loose as it gets!
  return comp.trim().replace(re[STAR], '');
}

// This function is passed to string.replace(re[HYPHENRANGE])
// M, m, patch, prerelease, build
// 1.2 - 3.4.5 => >=1.2.0-0 <=3.4.5
// 1.2.3 - 3.4 => >=1.2.0-0 <3.5.0-0 Any 3.4.x will do
// 1.2 - 3.4 => >=1.2.0-0 <3.5.0-0
function hyphenReplace($0,
                       from, fM, fm, fp, fpr, fb,
                       to, tM, tm, tp, tpr, tb) {

  if (isX(fM))
    from = '';
  else if (isX(fm))
    from = '>=' + fM + '.0.0-0';
  else if (isX(fp))
    from = '>=' + fM + '.' + fm + '.0-0';
  else
    from = '>=' + from;

  if (isX(tM))
    to = '';
  else if (isX(tm))
    to = '<' + (+tM + 1) + '.0.0-0';
  else if (isX(tp))
    to = '<' + tM + '.' + (+tm + 1) + '.0-0';
  else if (tpr)
    to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
  else
    to = '<=' + to;

  return (from + ' ' + to).trim();
}


// if ANY of the sets match ALL of its comparators, then pass
Range.prototype.test = function(version) {
  if (!version)
    return false;
  for (var i = 0; i < this.set.length; i++) {
    if (testSet(this.set[i], version))
      return true;
  }
  return false;
};

function testSet(set, version) {
  for (var i = 0; i < set.length; i++) {
    if (!set[i].test(version))
      return false;
  }
  return true;
}

exports.satisfies = satisfies;
function satisfies(version, range, loose) {
  try {
    range = new Range(range, loose);
  } catch (er) {
    return false;
  }
  return range.test(version);
}

exports.maxSatisfying = maxSatisfying;
function maxSatisfying(versions, range, loose) {
  return versions.filter(function(version) {
    return satisfies(version, range, loose);
  }).sort(function(a, b) {
    return rcompare(a, b, loose);
  })[0] || null;
}

exports.validRange = validRange;
function validRange(range, loose) {
  try {
    // Return '*' instead of '' so that truthiness works.
    // This will throw if it's invalid anyway
    return new Range(range, loose).range || '*';
  } catch (er) {
    return null;
  }
}

// Determine if version is less than all the versions possible in the range
exports.ltr = ltr;
function ltr(version, range, loose) {
  return outside(version, range, '<', loose);
}

// Determine if version is greater than all the versions possible in the range.
exports.gtr = gtr;
function gtr(version, range, loose) {
  return outside(version, range, '>', loose);
}

exports.outside = outside;
function outside(version, range, hilo, loose) {
  version = new SemVer(version, loose);
  range = new Range(range, loose);

  var gtfn, ltefn, ltfn, comp, ecomp;
  switch (hilo) {
    case '>':
      gtfn = gt;
      ltefn = lte;
      ltfn = lt;
      comp = '>';
      ecomp = '>=';
      break;
    case '<':
      gtfn = lt;
      ltefn = gte;
      ltfn = gt;
      comp = '<';
      ecomp = '<=';
      break;
    default:
      throw new TypeError('Must provide a hilo val of "<" or ">"');
  }

  // If it satisifes the range it is not outside
  if (satisfies(version, range, loose)) {
    return false;
  }

  // From now on, variable terms are as if we're in "gtr" mode.
  // but note that everything is flipped for the "ltr" function.

  for (var i = 0; i < range.set.length; ++i) {
    var comparators = range.set[i];

    var high = null;
    var low = null;

    comparators.forEach(function(comparator) {
      high = high || comparator;
      low = low || comparator;
      if (gtfn(comparator.semver, high.semver, loose)) {
        high = comparator;
      } else if (ltfn(comparator.semver, low.semver, loose)) {
        low = comparator;
      }
    });

    // If the edge version comparator has a operator then our version
    // isn't outside it
    if (high.operator === comp || high.operator === ecomp) {
      return false;
    }

    // If the lowest version comparator has an operator and our version
    // is less than it then it isn't higher than the range
    if ((!low.operator || low.operator === comp) &&
        ltefn(version, low.semver)) {
      return false;
    } else if (low.operator === ecomp && ltfn(version, low.semver)) {
      return false;
    }
  }
  return true;
}

// Use the define() function if we're in AMD land
if (typeof define === 'function' && define.amd)
  define(exports);

},{}],2:[function(require,module,exports){

/*
ADOBE SYSTEMS INCORPORATED
Copyright 2013 Adobe Systems Incorporated. All Rights Reserved.

NOTICE:  Adobe permits you to use, modify, and distribute this file in
accordance with the terms of the Adobe license agreement accompanying it.
If you have received this file from a source other than Adobe, then your
use, modification, or distribution of it requires the prior written
permission of Adobe.
*/

/**
 * Stores constants for the window types supported by the CSXS infrastructure.
 */
function CSXSWindowType()
{
};

/** Constant for the CSXS window type Panel. **/
CSXSWindowType._PANEL = "Panel";

/** Constant for the CSXS window type Modeless. **/
CSXSWindowType._MODELESS = "Modeless";

/** Constant for the CSXS window type ModalDialog. **/
CSXSWindowType._MODAL_DIALOG = "ModalDialog";

/** EvalScript error message**/
EvalScript_ErrMessage = "EvalScript error.";

/**
 * Class Version
 * Defines a version number with major, minor, micro, and special
 * components. The major, minor and micro values are numeric; the special
 * value can be any string.
 *
 * @param major   The major version component, a positive integer up to nine digits long.
 * @param minor   The minor version component, a positive integer up to nine digits long.
 * @param micro   The micro version component, a positive integer up to nine digits long.
 * @param special The special version component, an arbitrary string.
 *
 * @return A Version object.
 */
function Version(major, minor, micro, special)
{
	this.major = major;
	this.minor = minor;
	this.micro = micro;
	this.special = special;
};

/**
 * The maximum value allowed for a Numeric version component.
 * This reflects the maximum value allowed in PlugPlug and the manifest schema.
 */
Version.MAX_NUM = 999999999;

/**
 * Class VersionBound
 * Defines a boundary for a version range, which associates a Version object with a flag for whether it is an inclusive
 * or exclusive boundary.
 *
 * @param version   The Version object.
 *					@see Version class.
 * @param inclusive True if this boundary is inclusive, false if it is exclusive.
 *
 * @return A VersionBound object.
 */
function VersionBound(version, inclusive)
{
	this.version = version;
	this.inclusive = inclusive;
};

/**
 * Class VersionRange.
 * Defines a range of versions using a lower boundary and optional upper boundary.
 *
 * @param lowerBound The VersionBound object. @see VersionBound.
 * @param upperBound The VersionBound object, or null for a range with no upper boundary. @see VersionBound.
 *
 * @return A VersionRange object.
 */
function VersionRange(lowerBound, upperBound)
{
	this.lowerBound = lowerBound;
	this.upperBound = upperBound;
};

/**
 * Class Runtime.
 * Represents a runtime related to the CSXS infrastructure. Extensions can declare dependencies on particular
 * CSXS runtime versions in the extension manifest.
 *
 * @param name 	  The runtime name.
 * @param version The VersionRange object. @see VersionRange.
 *
 * @return A Runtime object.
 */
function Runtime(name, versionRange)
{
	this.name = name;
	this.versionRange = versionRange;
};

/**
* Class Extension.
* Contains the classes that define data types for the CEP libraries.
*
* @param id 					 The unique identifier of this extension.
* @param name 					 The localizable display name of this extension.
* @param mainPath 				 The path of the "index.html" file.
* @param basePath 				 The base path of this extension.
* @param windowType 			 The window type of the main window of this extension. Valid values are defined by CSXSWindowType. @see CSXSWindowType.
* @param width 					 The default width in pixels of the main window of this extension.
* @param height 				 The default height in pixels of the main window of this extension.
* @param minWidth 				 The minimum width in pixels of the main window of this extension.
* @param minHeight 				 The minimum height in pixels of the main window of this extension.
* @param maxWidth 				 The maximum width in pixels of the main window of this extension.
* @param maxHeight 				 The maximum height in pixels of the main window of this extension.
* @param defaultExtensionDataXml The extension data contained in the default ExtensionDispatchInfo section of the extension manifest.
* @param specialExtensionDataXml The extension data contained in the application-specific ExtensionDispatchInfo section of the extension manifest.
* @param requiredRuntimeList 	 An array of Runtime objects for runtimes required by this extension. @see VersionRange.
* @param isAutoVisible 			 True if this extension is visible on loading.
* @param isPluginExtension 		 True if this extension has been deployed in the Plugins folder of the host application.
*
* @return An Extension object.
*/
function Extension(id, name, mainPath, basePath, windowType, width, height, minWidth, minHeight, maxWidth, maxHeight,
				   defaultExtensionDataXml, specialExtensionDataXml, requiredRuntimeList, isAutoVisible, isPluginExtension)
{
	this.id = id;
	this.name = name;
	this.mainPath = mainPath;
	this.basePath = basePath;
	this.windowType = windowType;
	this.width = width;
	this.height = height;
	this.minWidth = minWidth;
	this.minHeight = minHeight;
	this.maxWidth = maxWidth;
	this.maxHeight = maxHeight;
	this.defaultExtensionDataXml = defaultExtensionDataXml;
	this.specialExtensionDataXml = specialExtensionDataXml;
	this.requiredRuntimeList = requiredRuntimeList;
	this.isAutoVisible = isAutoVisible;
	this.isPluginExtension = isPluginExtension;
};

/**
 * Class CSEvent.
 * You can use it to dispatch a standard Javascript event.
 *
 * @param type 		  Event type.
 * @param scope 	  The scope of event, can be "GLOBAL" or "APPLICATION".
 * @param appId 	  The unique identifier of the application that generated the event.
 * @param extensionId The unique identifier of the extension that generated the event.
 *
 * @return CSEvent object
 */
function CSEvent(type, scope, appId, extensionId)
{
    this.type = type;
    this.scope = scope;
    this.appId = appId;
    this.extensionId = extensionId;
};

/** The event specific data. **/
CSEvent.prototype.data = "";

/**
 * Class SystemPath
 * Stores operating-system-specific location constants for use getSystemPath method.
 */
function SystemPath()
{
};

/** Identifies the path to user data.  */
SystemPath.USER_DATA = "userData";

/** Identifies the path to common files for Adobe applications.  */
SystemPath.COMMON_FILES = "commonFiles";

/** Identifies the path to the user's default document folder.  */
SystemPath.MY_DOCUMENTS = "myDocuments";

/** Identifies the path to current extension.  */
/** DEPRECATED, PLEASE USE EXTENSION INSTEAD.  */
SystemPath.APPLICATION = "application";

/** Identifies the path to current extension.  */
SystemPath.EXTENSION = "extension";

/** Identifies the path to hosting application's executable.  */
SystemPath.HOST_APPLICATION = "hostApplication";

/**
 * Class ColorType
 * Stores the color-type constants.
 */
function ColorType()
{
};

/** rgb type. */
ColorType.RGB = "rgb";

/** gradient type. */
ColorType.GRADIENT = "gradient";

/** none type. */
ColorType.NONE = "none";

/**
 * Class RGBColor
 * Stores an RGB color with red, green, blue, and alpha values. All values are in the range
 * [0.0 to 255.0]. Invalid numeric values are converted to numbers within this range.
 *
 * @param red   The red value, in the range [0.0 to 255.0].
 * @param green The green value, in the range [0.0 to 255.0].
 * @param blue  The blue value, in the range [0.0 to 255.0].
 * @param alpha The alpha (transparency) value, in the range [0.0 to 255.0].
 * 		  		The default (255.0) means that the color is fully opaque.
 *
 * @return RGBColor object.
 */
function RGBColor(red, green, blue, alpha)
{
	this.red = red;
	this.green = green;
	this.blue = blue;
	this.alpha = alpha;
};

/**
 * Class Direction
 * Stores a point information.
 *
 * @param x X axis position.
 * @param y Y axis position.
 *
 * @return Direction object.
 */
function Direction(x, y)
{
	this.x = x;
	this.y = y;
};

/**
 * Class GradientStop
 * Stores gradient stop information.
 *
 * @param offset   The offset of the gradient stop, in the range [0.0 to 1.0].
 * @param rgbColor The RGBColor object. @see RGBColor.
 *
 * @return GradientStop object.
 */
function GradientStop(offset, rgbColor)
{
	this.offset = offset;
	this.rgbColor = rgbColor;
};

/**
 * Class GradientColor
 * Stores gradient color information.
 *
 * @param type 		 	   The gradient type, the only valid value is "linear".
 * @param direction 	   A vector describing the direction of the gradient.
 *						   A point value, in which the y component is 0 and the x component
 *						   is positive or negative for a right or left direction,
 * 						   or the x component is 0 and the y component is positive or negative for
 *						   an up or down direction. @see Direction.
 * @param numStops  	   The number of stops.
 * @param gradientStopList An array of GradientStop objects. @see GradientStop.
 *
 * @return GradientColor object.
 */
function GradientColor(type, direction, numStops, arrGradientStop)
{
	this.type = type;
	this.direction = direction;
	this.numStops = numStops;
	this.arrGradientStop = arrGradientStop;
};

/**
 * Class UIColor
 * Stores color information, including the type, anti-alias level, and specific color
 * values in a color object of an appropriate type.
 *
 * @param type 			 The color type constant, 1 for "rgb" and 2 for "gradient".
 * @param antialiasLevel The anti-alias level constant.
 * @param color 		 A GradientColor object or a RGBColor containing specific color information.
 *						 The type of color object depends on type parameter. @see GradientColor and RGBColor.
 *
 * @return UIColor object.
 */
function UIColor(type, antialiasLevel, color)
{
	this.type = type;
	this.antialiasLevel = antialiasLevel;
	this.color = color;
};

/**
 * Class AppSkinInfo
 * Stores window-skin properties, such as color and font. All parameters' type are UIColor. @see UIColor.
 *
 * @param baseFontFamily 			The base font family of the application.
 * @param baseFontSize 				The base font size of the application.
 * @param appBarBackgroundColor 	The application bar background color.
 * @param panelBackgroundColor 		The background color of the extension panel.
 * @param appBarBackgroundColorSRGB The application bar background color, as sRGB.
 * @param panelBackgroundColorSRGB  The background color of the extension panel, as sRGB.
 * @param systemHighlightColor      The operating-system highlight color, as sRGB.
 *
 * @return AppSkinInfo object.
 */
function AppSkinInfo(baseFontFamily, baseFontSize, appBarBackgroundColor, panelBackgroundColor, appBarBackgroundColorSRGB, panelBackgroundColorSRGB, systemHighlightColor)
{
	this.baseFontFamily = baseFontFamily;
	this.baseFontSize = baseFontSize;
	this.appBarBackgroundColor = appBarBackgroundColor;
	this.panelBackgroundColor = panelBackgroundColor;
	this.appBarBackgroundColorSRGB = appBarBackgroundColorSRGB;
	this.panelBackgroundColorSRGB = panelBackgroundColorSRGB;
	this.systemHighlightColor = systemHighlightColor;
};

/**
 * Class HostEnvironment
 * Stores information about the environment in which the extension is loaded.
 *
 * @param appName 	   The application's name.
 * @param appVersion   The application's version.
 * @param appLocale    The application's current license locale.
 * @param appId 	   The application's unique identifier.
 * @param isAppOffline True if the application is currently offline.
 * @param appSkinInfo  A skin-information object containing the application's default color and font styles. @see AppSkinInfo.
 * @param appUILocale  The application's current UI locale.
 *
 * @return HostEnvironment object.
 */
function HostEnvironment(appName, appVersion, appLocale, appUILocale, appId, isAppOffline, appSkinInfo)
{
	this.appName = appName;
	this.appVersion = appVersion;
	this.appLocale = appLocale;
	this.appUILocale = appUILocale;
	this.appId = appId;
	this.isAppOffline = isAppOffline;
	this.appSkinInfo = appSkinInfo;
};

/***********************************************************************************/
/**
 * Class CSInterface.
 * You can use it to communicate with native application.
 *
 * @return CSInterface object
 */
function CSInterface()
{
};

/**
 * User can add this event listener to handle native application theme color changes.
 * Callback function gives extensions ability to fine-tune their theme color after the
 * global theme color has been changed.
 * The callback function should be like below:
 *
 * @example
 * // event is a CSEvent object, but user can ignore it.
 * function OnAppThemeColorChanged(event)
 * {
 *	  // Should get a latest HostEnvironment object from application.
 *	  var skinInfo = JSON.parse(window.__adobe_cep__.getHostEnvironment()).appSkinInfo;
 *    // Gets the style information such as color info from the skinInfo,
 *	  // and redraw all UI controls of your extension according to the style info.
 * }
 */
CSInterface.THEME_COLOR_CHANGED_EVENT = "com.adobe.csxs.events.ThemeColorChanged";

/** The host environment data object **/
CSInterface.prototype.hostEnvironment = JSON.parse(window.__adobe_cep__.getHostEnvironment());

/** Close the current extension **/
CSInterface.prototype.closeExtension = function()
{
	window.__adobe_cep__.closeExtension();
};

/**
 * Get system path.
 *
 * @param pathType A string containing a path-type constant defined in the SystemPath class,
 * 		           such as SystemPath.USER_DATA.
 * @return path string
 */
CSInterface.prototype.getSystemPath = function(pathType)
{
	var path = decodeURI(window.__adobe_cep__.getSystemPath(pathType));
	var OSVersion = this.getOSInformation();
	if (OSVersion.indexOf("Windows") >= 0)
	{
	  path = path.replace("file:///", "");
	}
	else if (OSVersion.indexOf("Mac") >= 0)
	{
	  path = path.replace("file://", "");
	}
    return path;
};

/**
 * Eval scripts. You can use it to operate the DOM of native application.
 *
 * @param script   The raw JavaScript.
 * @param callback The callback function that receives the execution result of the script. This parameter is optional.
 * 				   If it fails to execute the script, the callback function will receive the error message EvalScript_ErrMessage.
 */
CSInterface.prototype.evalScript = function(script, callback)
{
    if(callback == null || callback == undefined)
    {
        callback = function(result){};
    }
    window.__adobe_cep__.evalScript(script, callback);
};

/**
 * Get the identifier of the host application.
 *
 * @return a string identifier of the host application
 */
CSInterface.prototype.getApplicationID = function()
{
    var appId = this.hostEnvironment.appId;
    return appId;
};

/**
 * Get host capability information about the host application.
 *
 * @return an object that contains host capability information
 */
CSInterface.prototype.getHostCapabilities = function()
{
    var hostCapabilities = JSON.parse(window.__adobe_cep__.getHostCapabilities() );
    return hostCapabilities;
};

/**
 * Triggering a CS Event programmatically. You can use it to dispatch a CSEvent.
 *
 * @param event a CS Event
 */
CSInterface.prototype.dispatchEvent = function(event)
{
    if (typeof event.data == "object")
    {
        event.data = JSON.stringify(event.data);
    }

    window.__adobe_cep__.dispatchEvent(event);
};

/**
 * Register a CS Event listener. You can use it to listen a CSEvent.
 *
 * @param type     The Event type
 * @param listener The JavaScript function that receives a notification when
 *                 a CS event of the specified type occurs.
 * @param obj 	   The object that listener belongs to. Use it when listener is a method
 *				   of an object. This parameter is optional and its default value is null.
 */
CSInterface.prototype.addEventListener = function(type, listener, obj)
{
    window.__adobe_cep__.addEventListener(type, listener, obj);
};

/**
 * Remove the CS Event listener.
 *
 * @param type event type
 * @param listener The JavaScript function that receives a notification when
 *                 a CS event of the specified type occurs.
 * @param obj 	   The object that listener belongs to. Use it when listener is a method
 *				   of an object. This parameter is optional and its default value is null.
 */
CSInterface.prototype.removeEventListener = function(type, listener, obj)
{
    window.__adobe_cep__.removeEventListener(type, listener, obj);
};

/**
 * Loads and launches another extension. If the target extension is already loaded, it is activated.
 *
 * @param extensionId   The extension's unique identifier.
 * @param startupParams Startup parameters to be passed to the loaded extension.
 * 	 					Specify key-value pairs as a GET URL parameter list; for example: "key1=value1&amp;key2=value2".
 *						Currently this parameter is not supported by CEP, so it will always be "" for now.
 *
 * @example
 * To launch the extension "help" with ID "HLP" from this extension, call:
 * requestOpenExtension("HLP", "");
 *
 */
CSInterface.prototype.requestOpenExtension = function(extensionId, params)
{
	window.__adobe_cep__.requestOpenExtension(extensionId, params);
};

/**
 * Retrieves the list of extensions currently loaded in the current host application.
 * The extension list is initialized once, and remains the same during the lifetime of the CSXS session.
 *
 * @param extensionIds An array of unique identifiers for extensions of interest.
 * 					   If omitted, retrieves data for all extensions.
 *
 * @return An Extension object.
 */
CSInterface.prototype.getExtensions = function(extensionIds)
{
	var extensionIdsStr = JSON.stringify(extensionIds);
	var extensionsStr = window.__adobe_cep__.getExtensions(extensionIdsStr);

	var extensions = JSON.parse(extensionsStr);
	return extensions;
};

/**
 * Retrieves network-related preferences.
 *
 * @return A NetworkPreferences object.
 */
CSInterface.prototype.getNetworkPreferences = function()
{
	var result = window.__adobe_cep__.getNetworkPreferences();
	var networkPre = JSON.parse(result);

	return networkPre;
};

/**
 * Initializes the resource bundle for this extension with property values for the current application and locale.
 * If user wants to support multi-locale to the extension, they should define a property file. An example of the property file content is:
 *
 *  key1=value1
 *  key2=value2
 *	key3.value=value3
 *
 * The property file should be placed in its corresponding locale folder. For example for en_US, the property file would be placed in YourExtension/locale/en_US/messages.properties.
 * Users can define a default property file, placed in "YourExtension/locale/" which will be used when the corresponding locale file is not defined.
 * Users should initialize locale strings during the loading of the extension. The locale loaded should match the current UI locale of the host application.
 * 'data-locale' is the custom HTML element attribute and you can added it to each HTML element that you want to localize.
 *
 * For example:
 *
 *	<input type="submit" value="" data-locale="key3"/>
 *	<script type="text/javascript">
 *		var cs = new CSInterface();
 *		// Get properties according to current locale of host application.
 *		var resourceBundle = cs.initResourceBundle();
 *		// Refer the locale string.
 *		document.write(resourceBundle.key1);
 *		document.write(resourceBundle.key2);
 *	</script>
 *
 * @return An object containing the resource bundle information.
 */
CSInterface.prototype.initResourceBundle = function()
{
	var resourceBundle = JSON.parse(window.__adobe_cep__.initResourceBundle());
	var resElms = document.querySelectorAll('[data-locale]');
	for (var n = 0; n < resElms.length; n++)
	{
	   var resEl = resElms[n];
	   // Get the resource key from the element.
	   var resKey = resEl.getAttribute('data-locale');
	   if (resKey)
	   {
		   // Get all the resources that start with the key.
		   for (var key in resourceBundle)
		   {
			   if (key.indexOf(resKey) == 0)
			   {
				   var resValue = resourceBundle[key];
				   if (key.indexOf('.') == -1)
				   {
					   // No dot notation in resource key,
					   // assign the resource value to the element's
					   // innerHTML.
					   resEl.innerHTML = resValue;
				   }
				   else
				   {
					   // Dot notation in resource key, assign the
					   // resource value to the element's property
					   // whose name corresponds to the substring
					   // after the dot.
					   var attrKey = key.substring(key.indexOf('.') + 1);
					   resEl[attrKey] = resValue;
				   }
			   }
		   }
	   }
	}
	return resourceBundle;
};

/**
 * Writes installation information to a file.
 *
 * @return The dump info file path.
 */
CSInterface.prototype.dumpInstallationInfo = function()
{
	return window.__adobe_cep__.dumpInstallationInfo();
};

/**
 * Get current Operating System information including version and 32-bit/64-bit.
 * Refer to http://www.useragentstring.com/pages/Chrome/ for all of the navigator.userAgent values retrieved by Chrome.
 *
 * @return The OS version in string or "unknown Operation System".
 */
CSInterface.prototype.getOSInformation = function()
{
    var userAgent = navigator.userAgent;

    if ((navigator.platform == "Win32") || (navigator.platform == "Windows"))
    {
        var winVersion = "Windows platform";
        if (userAgent.indexOf("Windows NT 5.0") > -1)
        {
            winVersion = "Windows 2000";
        }
        else if (userAgent.indexOf("Windows NT 5.1") > -1)
        {
            winVersion = "Windows XP";
        }
        else if (userAgent.indexOf("Windows NT 5.2") > -1)
        {
            winVersion = "Windows Server 2003";
        }
        else if (userAgent.indexOf("Windows NT 6.0") > -1)
        {
            winVersion = "Windows Vista";
        }
        else if (userAgent.indexOf("Windows NT 6.1") > -1)
        {
            winVersion = "Windows 7";
        }
        else if (userAgent.indexOf("Windows NT 6.2") > -1)
        {
            winVersion = "Windows 8";
        }

        var winBit = "32-bit";
        if (userAgent.indexOf("WOW64") > -1)
        {
            winBit = "64-bit";
        }

        return winVersion + " " + winBit;
    }
    else if ((navigator.platform == "MacIntel") || (navigator.platform == "Macintosh"))
    {
        var agentStr = new String();
        agentStr = userAgent;
		var verLength = agentStr.indexOf(")") - agentStr.indexOf("Mac OS X");
		var verStr = agentStr.substr(agentStr.indexOf("Mac OS X"), verLength);
		var result = verStr.replace("_", ".");
		result = result.replace("_", ".");
        return result;
    }

    return "Unknown Operation System";
};

;
CSInterface.SystemPath = SystemPath;

CSInterface.CSEvent = CSEvent;

module.exports = CSInterface;

},{}],3:[function(require,module,exports){
var CSInterface, Form, OpenInBrowserHelper, Panel, Rotator, ThemeHandler, UpdateNotifier;

window.CC = window.__adobe_cep__ != null;

require('./polyfills');

OpenInBrowserHelper = require('./widgets/OpenInBrowserHelper');

UpdateNotifier = require('./panel/UpdateNotifier');

ThemeHandler = require('./ThemeHandler');

if (window.CC) {
  CSInterface = require('./CSInterface');
}

Rotator = require('./widgets/Rotator');

Form = require('./widgets/Form');

module.exports = Panel = (function() {
  function Panel(panelName, rootNode, options) {
    this.panelName = panelName;
    this.rootNode = rootNode != null ? rootNode : document.body;
    this.options = options;
    if (window.CC) {
      this.csi = new CSInterface;
    }
    this.themeHandler = new ThemeHandler(this);
    Rotator.applyTo(this.rootNode, this);
    Form.applyTo(this.rootNode, this);
    OpenInBrowserHelper.applyTo(this.rootNode, this);
    this.updateNotifier = new UpdateNotifier(this);
  }

  Panel.prototype.setPersistency = function(isOn, id) {
    var event;
    if (!window.CC) {
      return;
    }
    if (isOn) {
      event = new CSInterface.CSEvent("com.adobe.PhotoshopPersistent", "APPLICATION");
    } else {
      event = new CSInterface.CSEvent("com.adobe.PhotoshopUnPersistent", "APPLICATION");
    }
    event.extensionId = id;
    return this.csi.dispatchEvent(event);
  };

  return Panel;

})();

},{"./CSInterface":2,"./ThemeHandler":4,"./panel/UpdateNotifier":5,"./polyfills":6,"./widgets/Form":7,"./widgets/OpenInBrowserHelper":8,"./widgets/Rotator":9}],4:[function(require,module,exports){
var ThemeHandler,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

module.exports = ThemeHandler = (function() {
  function ThemeHandler(panel) {
    this.panel = panel;
    this._themeChangeListenerCS = __bind(this._themeChangeListenerCS, this);
    this._themeChangeListenerCC = __bind(this._themeChangeListenerCC, this);
    this.current = 'light1';
    this._changeTheme('dark1', 'Tahoma', '10');
    if (window.CC) {
      this.panel.csi.addEventListener(this.panel.csi.constructor.THEME_COLOR_CHANGED_EVENT, this._themeChangeListenerCC);
      this._themeChangeListenerCC();
    } else {
      window.addEventListener('ThemeChangedEvent', this._themeChangeListenerCS);
    }
  }

  ThemeHandler.prototype._themeChangeListenerCC = function() {
    var color, skin, theme;
    skin = this.panel.csi.hostEnvironment.appSkinInfo;
    color = skin.panelBackgroundColor.color;
    theme = color.red > 200 ? 'light2' : color.red > 120 ? 'light1' : color.red > 75 ? 'dark2' : 'dark1';
    return this._changeTheme(theme, skin.baseFontFamily, skin.baseFontSize);
  };

  ThemeHandler.prototype._themeChangeListenerCS = function(e) {
    var bgColor, skin, theme;
    bgColor = e.appSkinInfo.panelBackgroundColor;
    theme = (function() {
      switch (bgColor) {
        case '343434':
          return 'dark1';
        case 'b8b8b8':
          return 'light1';
        case 'd6d6d6':
          return 'light2';
        default:
          return 'dark2';
      }
    })();
    skin = e.appSkinInfo;
    return this._changeTheme(theme, skin.baseFontFamily, skin.baseFontSize);
  };

  ThemeHandler.prototype._changeTheme = function(theme, fontFamily, fontSize) {
    var body, html, s, size, t, _i, _j, _len, _len1, _ref, _ref1;
    html = document.querySelector('html');
    body = document.body;
    body.style.fontFamily = fontFamily;
    body.style.fontSize = fontSize + 'px';
    _ref = ['light1', 'light2', 'dark1', 'dark2', 'light', 'dark'];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      t = _ref[_i];
      html.classList.remove(t);
    }
    html.classList.add(theme);
    if (theme === 'light1' || theme === 'light2') {
      html.classList.add('light');
    } else {
      html.classList.add('dark');
    }
    this.current = theme;
    size = fontSize <= 10 ? 'small' : fontSize < 12 ? 'medium' : 'large';
    _ref1 = ['small', 'medium', 'big'];
    for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
      s = _ref1[_j];
      html.classList.remove("size-" + s);
    }
    html.classList.add("size-" + size);
  };

  ThemeHandler.prototype.isLight = function() {
    var _ref;
    return (_ref = this.current) === 'light1' || _ref === 'light2';
  };

  return ThemeHandler;

})();

},{}],5:[function(require,module,exports){
var UpdateNotifier, semver,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

semver = require('semver/semver.js');

module.exports = UpdateNotifier = (function() {
  function UpdateNotifier(panel) {
    this.panel = panel;
    this._close = __bind(this._close, this);
  }

  UpdateNotifier.prototype.init = function(options) {
    this.name = options.name;
    this.version = options.version;
    this.hub = options.hub;
    this.channel = options.channel;
    this.updateUrl = options.updateUrl;
    this.request = new XMLHttpRequest;
    this.request.onreadystatechange = (function(_this) {
      return function() {
        if (_this.request.readyState === 4) {
          return _this._processResult(_this.request.responseText);
        }
      };
    })(this);
    this.request.open('GET', this.hub, true);
    return this.request.send(null);
  };

  UpdateNotifier.prototype._processResult = function(response) {
    var json, latestVersionOnChannel;
    json = JSON.parse(response);
    if (!((json.channels != null) && (json.channels[this.channel] != null))) {
      return;
    }
    latestVersionOnChannel = json.channels[this.channel];
    if (semver.gt(latestVersionOnChannel, this.version)) {
      return this._considerShowingUpdateNotification();
    }
  };

  UpdateNotifier.prototype._considerShowingUpdateNotification = function() {
    return this._showUpdateNotification();
  };

  UpdateNotifier.prototype._showUpdateNotification = function() {
    this.node = document.createElement('div');
    this.node.className = "serverNotification visible";
    document.body.appendChild(this.node);
    this.linkNode = document.createElement('a');
    this.linkNode.className = "serverNotification-msg browse";
    this.linkNode.href = this.updateUrl;
    this.linkNode.innerHTML = 'New Version Available at ' + this.updateUrl.replace('http://', '');
    this.node.appendChild(this.linkNode);
    this.closeNode = document.createElement('button');
    this.closeNode.className = "serverNotification-discard";
    this.closeNode.innerHTML = "Remind Me Later";
    this.node.appendChild(this.closeNode);
    this.linkNode.addEventListener('click', this._close);
    return this.closeNode.addEventListener('click', this._close);
  };

  UpdateNotifier.prototype._close = function() {
    return this.node.classList.remove('visible');
  };

  return UpdateNotifier;

})();

},{"semver/semver.js":1}],6:[function(require,module,exports){

(function () {

if (typeof window.Element === "undefined" || "classList" in document.documentElement) return;

var prototype = Array.prototype,
    push = prototype.push,
    splice = prototype.splice,
    join = prototype.join;

function DOMTokenList(el) {
  this.el = el;
  // The className needs to be trimmed and split on whitespace
  // to retrieve a list of classes.
  var classes = el.className.replace(/^\s+|\s+$/g,'').split(/\s+/);
  for (var i = 0; i < classes.length; i++) {
    push.call(this, classes[i]);
  }
};

DOMTokenList.prototype = {
  add: function(token) {
    if(this.contains(token)) return;
    push.call(this, token);
    this.el.className = this.toString();
  },
  contains: function(token) {
    return this.el.className.indexOf(token) != -1;
  },
  item: function(index) {
    return this[index] || null;
  },
  remove: function(token) {
    if (!this.contains(token)) return;
    for (var i = 0; i < this.length; i++) {
      if (this[i] == token) break;
    }
    splice.call(this, i, 1);
    this.el.className = this.toString();
  },
  toString: function() {
    return join.call(this, ' ');
  },
  toggle: function(token) {
    if (!this.contains(token)) {
      this.add(token);
    } else {
      this.remove(token);
    }

    return this.contains(token);
  }
};

window.DOMTokenList = DOMTokenList;

function defineElementGetter (obj, prop, getter) {
    if (Object.defineProperty) {
        Object.defineProperty(obj, prop,{
            get : getter
        });
    } else {
        obj.__defineGetter__(prop, getter);
    }
}

defineElementGetter(Element.prototype, 'classList', function () {
  return new DOMTokenList(this);
});

})();
;
if (String.prototype.trim == null) {
  String.prototype.trim = function() {
    return this.replace(/^\s+|\s+$/g, '');
  };
}

},{}],7:[function(require,module,exports){
var Form;

module.exports = Form = (function() {
  function Form(panel, node) {
    this.panel = panel;
    this.node = node;
    this.csi = this.panel.csi;
    this.node.addEventListener('submit', (function(_this) {
      return function(e) {
        e.preventDefault();
        return _this._submit();
      };
    })(this));
  }

  Form.prototype._submit = function() {
    var data, input, json, _i, _len, _ref;
    data = {};
    _ref = this.node.querySelectorAll('input');
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      input = _ref[_i];
      data[input.name] = input.value;
    }
    json = JSON.stringify(data);
    return this._wire(json);
  };

  Form.prototype._wire = function(data) {
    var action, args, e, file, matches, method, obj, src;
    action = this.node.action;
    if (!(matches = action.match(/\#([a-zA-Z0-9\_]+)$/))) {
      throw Error("Couldn't parse action address '" + action + "'");
    }
    method = matches[1];
    try {
      if (window.CC) {
        src = "$.global._panels." + method + ("(" + data + ");");
        this.csi.evalScript(src, function(ret) {
          return console.log(arguments);
        });
      } else {
        file = this.panel.options.jsx;
        obj = '_panels';
        args = [data];
        _AdobeInvokeFunctionInScriptFile(file, obj, method, args);
      }
    } catch (_error) {
      e = _error;
      console.error(e);
    }
  };

  Form.applyTo = function(rootNode, panel) {
    var form, _i, _len, _ref;
    _ref = rootNode.querySelectorAll('form');
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      form = _ref[_i];
      if (String(form.getAttribute('action')).match(/^#/)) {
        new Form(panel, form);
      }
    }
  };

  return Form;

})();

},{}],8:[function(require,module,exports){
var OpenInBrowserHelper;

module.exports = OpenInBrowserHelper = (function() {
  OpenInBrowserHelper.applyTo = function(node, panel) {
    return new OpenInBrowserHelper(node, panel);
  };

  function OpenInBrowserHelper(node, panel) {
    this.node = node;
    this.panel = panel;
    node.addEventListener('click', (function(_this) {
      return function(e) {
        var el;
        el = e.target;
        if (el.tagName === 'A' && el.classList.contains('browse')) {
          e.preventDefault();
          return _this.browse(el.href, panel);
        }
      };
    })(this));
  }

  OpenInBrowserHelper.prototype.browse = function(url) {
    var isWindows, processPath, rootDir;
    isWindows = window.navigator.platform.toLowerCase().indexOf("win") > -1;
    rootDir = "/";
    if (isWindows) {
      rootDir = this.panel.csi.getSystemPath("commonFiles").substring(0, 3);
    }
    processPath = "/usr/bin/open";
    if (isWindows) {
      processPath = rootDir + "Windows/explorer.exe";
    }
    return window.cep.process.createProcess(processPath, url);
  };

  return OpenInBrowserHelper;

})();

},{}],9:[function(require,module,exports){
var Rotator,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

module.exports = Rotator = (function() {
  function Rotator(node) {
    var i, o, options, thingy, _i, _j, _len, _ref;
    this.node = node;
    this.rotate = __bind(this.rotate, this);
    this.name = this.node.getAttribute('data-name');
    options = this.node.getAttribute('data-options');
    if (!((options != null) && options.trim() !== '')) {
      throw Error("Rotator isn't supplied with data-options");
    }
    this.options = [];
    _ref = options.split(/\s*,\s*/);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      o = _ref[_i];
      this.options.push(o);
    }
    this.node.classList.add('panel-input-rotator');
    for (i = _j = 0; _j <= 6; i = ++_j) {
      thingy = document.createElement('div');
      thingy.classList.add('thingy');
      thingy.classList.add('n' + i);
      this.node.appendChild(thingy);
    }
    this.input = document.createElement('input');
    this.input.type = 'hidden';
    this.input.name = this.name;
    this.node.parentNode.appendChild(this.input);
    this.set(this.node.getAttribute('data-default') || this.options[0]);
    this.node.addEventListener('click', this.rotate);
  }

  Rotator.prototype.set = function(to) {
    if (__indexOf.call(this.options, to) < 0) {
      throw Error("Option '" + to + "' isn't defined.");
    }
    if (this.current != null) {
      this.node.classList.remove(this.current);
    }
    this.node.classList.add(to);
    this.current = to;
    this.input.value = to;
    return this;
  };

  Rotator.prototype.rotate = function() {
    var newIndex;
    newIndex = this.options.indexOf(this.current) + 1;
    newIndex = newIndex % this.options.length;
    this.set(this.options[newIndex]);
    return this;
  };

  Rotator.applyTo = function(root) {
    var node, nodes, _i, _len;
    nodes = root.querySelectorAll('[data-type="rotator"]');
    for (_i = 0, _len = nodes.length; _i < _len; _i++) {
      node = nodes[_i];
      new Rotator(node);
    }
  };

  return Rotator;

})();

},{}],10:[function(require,module,exports){
module.exports={
  "name": "griddify",
  "private": "true",
  "version": "1.0.0-beta.3",
  "description": "A tiny photoshop panel to make guides and grids",
  "main": "index.js",
  "scripts": {
    "prepublish": "cake build && compass compile styles",
    "winwatch": "start/b jitter scripts/coffee scripts/js -b && start/b compass watch styles && start/b watchify scripts/js/panel/panel.js --path js --noparse=FILE --dg false -o scripts/dist/panel.js -v && start/b watchify scripts/js/commands/commands.js --path js --noparse=FILE --dg false -o scripts/dist/commands.jsx -v",
    "watch": "jitter scripts/coffee scripts/js -b & compass watch styles & watchify scripts/js/panel/panel.js --path js --noparse=FILE --dg false -o scripts/dist/panel.js -v & watchify scripts/js/commands/commands.js --path js --noparse=FILE --dg false -o scripts/dist/commands.jsx -v"
  },
  "repository": {
    "type": "git",
    "url": "https://github.com/pixana/griddify.git"
  },
  "keywords": [
    "photoshop"
  ],
  "author": "Aria Minaei",
  "license": "GPL V3",
  "bugs": {
    "url": "https://github.com/pixana/griddify/issues"
  },
  "dependencies": {
    "photoshopjs-core": "~0.1.0-dev.1",
    "photoshopjs-panel": "~0.1.0-dev.1"
    },
  "devDependencies": {
    "browserify": "^4.1.5",
    "coffee-script": "^1.7.1",
    "jitter": "^1.3.0",
    "watchify": "^0.10.1"
  }
}

},{}],11:[function(require,module,exports){
var Panel, error, name, panel, version, _ref;

try {
  Panel = require('photoshopjs-panel');
  panel = new Panel('Griddify', document.body, {
    jsx: "./scripts/dist/commands.jsx"
  });
  _ref = require('../../../package.json'), name = _ref.name, version = _ref.version;
  panel.updateNotifier.init({
    name: name,
    version: version,
    channel: "cs6-beta",
    hub: "http://localhost/gelobi/griddify/updateHub2/",
    updateUrl: "http://gelobi.org/griddify"
  });
} catch (_error) {
  error = _error;
  alert(error);
}

},{"../../../package.json":10,"photoshopjs-panel":3}]},{},[11])